<template>
    <div>
        <p>You are {{!auth.type? 'Seller' : 'Buyer'}}</p>
        <div v-if="!auth.type">
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        <label>Make</label>
                        <input type="text" class="form-control" required :class="{hasError: errors.create.hasOwnProperty('make')}" v-model="newCar.make" />
                    </div>

                    <div class="form-group">
                        <label>Model</label>
                        <input type="text" class="form-control" required :class="{hasError: errors.create.hasOwnProperty('make')}" v-model="newCar.model" />
                    </div>
                </div>

                <div class="col-md-6">
                    <div class="form-group">
                        <label>Price</label>
                        <input type="text" class="form-control" required :class="{hasError: errors.create.hasOwnProperty('price')}" v-model="newCar.price" />
                    </div>

                    <div class="form-group">
                        <label>Year</label>
                        <input type="text" class="form-control" required :class="{hasError: errors.create.hasOwnProperty('year')}" v-model="newCar.year" />
                    </div>
                </div>
            </div>

            <div style="display: flex;justify-content: center;">
                <button class="btn btn-primary" @click.prevent="create()">Add Car</button>
            </div>
        </div>

        <table class="table table-striped" id="table" v-if="cars.data" style="margin-top: 15px;">
            <thead>
                <tr>
                    <th scope="col">#</th>
                    <th scope="col">Make</th>
                    <th scope="col">Model</th>
                    <th scope="col">Year</th>
                    <th scope="col">Price</th>
                    <th scope="col" v-if="auth.type===1">Owner</th>
                    <th scope="col" v-if="!auth.type">Actions</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="car in cars.data" :key="car.id">
                    <th scope="row">{{car.id}}</th>
                    <td>{{car['make']}}</td>
                    <td>{{car['model']}}</td>
                    <td>{{car['year']}}</td>
                    <td>{{car['price']}}</td>
                    <td v-if="!auth.type">
                        <button type="button" class="btn btn-info btn-m" data-toggle="modal" data-target="#exampleModal" @click="openModal(car)">
                            <i class="fa fa-pencil"></i>
                        </button>
                        <button @click.prevent="deleteCar(car.id)" class="btn btn-m btn-danger">
                            <i class="fa fa-trash"></i>
                        </button>
                    </td>
                    <th v-if="auth.type===1">
                        {{car['user']['name']}}
                    </th>
                </tr>
            </tbody>
        </table>

        <pagination :data="cars" @pagination-change-page="getList"></pagination>

        <div class="modal fade" tabindex="-1" role="dialog" id="exampleModal" ref="vuemodal">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label>Make</label>
                            <input type="text" class="form-control" required v-model="selected.make" :class="{hasError: errors.edit.hasOwnProperty('make')}" />
                        </div>
                        <div class="form-group">
                            <label>Model</label>
                            <input type="text" class="form-control" required v-model="selected.model" :class="{hasError: errors.edit.hasOwnProperty('model')}" />
                        </div>
                        <div class="form-group">
                            <label>Price</label>
                            <input type="text" class="form-control" required v-model="selected.price" :class="{hasError: errors.edit.hasOwnProperty('price')}" />
                        </div>
                        <div class="form-group">
                            <label>Year</label>
                            <input type="text" class="form-control" required v-model="selected.year" :class="{hasError: errors.edit.hasOwnProperty('year')}" />
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="button" class="btn btn-primary" @click.prevent="edit()">Save</button>
                    </div>
                </div>
            </div>
        </div>

    </div>
</template>

<script>
    export default {

    	data() {
			return {
				newCar: {
				    make: '',
                    model: '',
                    price: '',
                    year: ''
                },
				hasError: true,
				cars: [],
                selected: {
				    id: '',
                    make: '',
                    model: '',
                    price: '',
                    year: ''
                },
                errors: {
				    edit: {},
                    create: {}
                }
			}
        },

        props: {
    	    auth: [Object]
        },

        methods: {

			openModal(car) {
                this.selected.id = car.id;
                this.selected.make = car.make;
                this.selected.model = car.model;
                this.selected.price = car.price;
                this.selected.year = car.year;
            },

			create() {

			    axios.post('api/cars', this.newCar)
                .then(() => {
                    this.newCar = {'make': '', 'model': ''};
                    this.getList();
                }).catch((error) => {
                    this.errors.create = error.response.data.errors;
                });
			},

			getList(page=1) {
				axios.get('api/cars?page=' + page)
                .then((response) => {
                    this.cars = response.data;
                })
                .catch((error) => {
                    console.log(error);
                });
			},

            edit() {
				if (!this.selected) {return false;}
				axios.put('api/cars/' + this.selected.id, this.selected).then(() => {
                    $('#exampleModal').modal('hide');
                    this.getList();
				}).catch((error) => {
					this.errors.edit = error.response.data.errors;
                });
            },

            deleteCar(id) {
				axios.delete('api/cars/' + id).then(() => {
					this.getList();
				}).catch((error) => {
					console.log(error);
				});
			},

            closeModal() {
                this.errors.edit = {};
            },
        },

        mounted() {
            $(this.$refs.vuemodal).on("hidden.bs.modal", this.closeModal)
        },

        created() {
    		this.getList();
        }
    }
</script>

<style>
    .hasError {
        border: 1px solid #dc3545;
    }
</style>
